/*
**	PathPanel.c
**
**	Editing panel for path configuration
**
**	Copyright  1990-1995 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_AUPLOAD=1000,GAD_ADOWNLOAD,GAD_TUPLOAD,GAD_TDOWNLOAD,
		GAD_BUPLOAD,GAD_BDOWNLOAD,GAD_CONFIGSTORE,GAD_EDITOR,GAD_HELPFILE,

		GAD_USE,GAD_CANCEL,GAD_DEFAULT,
		GAD_PAGER,GAD_PAGEGROUP
	};

BYTE __regargs
PathPanel(struct Configuration *Config,BYTE *Default)
{
	STATIC LONG LabelTable[] =
	{
		MSG_PATHPANEL_DEFAULT_ASCII_UPLOAD_PATH_GAD,
		MSG_PATHPANEL_DEFAULT_ASCII_DOWNLOAD_PATH_GAD,
		MSG_PATHPANEL_DEFAULT_TEXT_UPLOAD_PATH_GAD,
		MSG_PATHPANEL_DEFAULT_TEXT_DOWNLOAD_PATH_GAD,
		MSG_PATHPANEL_DEFAULT_BINARY_UPLOAD_PATH_GAD,
		MSG_PATHPANEL_DEFAULT_BINARY_DOWNLOAD_PATH_GAD,
		MSG_PATHPANEL_CONFIGURATION_STORAGE_DIR_GAD,
		MSG_PATHPANEL_DEFAULT_TEXT_EDITOR_GAD,
		MSG_PATHPANEL_HELP_TEXT_FILE_GAD
	};

	STATIC LONG PageTitleID[5] =
	{
		MSG_V36_0121,
		MSG_V36_0122,
		MSG_V36_0123,
		MSG_V36_0124,
		-1
	};

	STATIC BYTE		 InitialPage = 0;

	LONG			 i,Max,Len;

	struct LayoutHandle	*Handle;
	BYTE			 Cancel = FALSE;
	STRPTR			 PageTitle[5];

	LocalizeStringTable(PageTitle,PageTitleID);

	SaveConfig(Config,PrivateConfig);

	if(Handle = LT_CreateHandleTags(Window -> WScreen,
		LH_LocaleHook,	&LocaleHook,
		LH_ExitFlush,	FALSE,
	TAG_DONE))
	{
		struct Window *PanelWindow;

		for(i = Max = 0 ; i < 9 ; i++)
		{
			if((Len = LT_LabelChars(Handle,LocaleString(LabelTable[i]))) > Max)
				Max = Len;
		}

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	CYCLE_KIND,
					LA_ID,		GAD_PAGER,
					LA_LabelID,	MSG_XFER_PAGE_TXT,
					GTCY_Labels,	PageTitle,
					LACY_AutoPageID,GAD_PAGEGROUP,
					LACY_TabKey,	TRUE,
					LA_BYTE,	&InitialPage,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_ID,		GAD_PAGEGROUP,
				LAGR_Frame,	TRUE,
				LAGR_ActivePage,InitialPage,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_PATHPANEL_DEFAULT_ASCII_UPLOAD_PATH_GAD,
						LA_ID,		GAD_AUPLOAD,
						LA_Chars,	20,
						LA_LabelChars,	Max,
						LAST_Picker,	TRUE,
						GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
						LA_STRPTR,	Config -> PathConfig -> ASCIIUploadPath,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_ADOWNLOAD,
						LA_LabelID,	MSG_PATHPANEL_DEFAULT_ASCII_DOWNLOAD_PATH_GAD,
						LA_LabelChars,	Max,
						LAST_Picker,	TRUE,
						GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
						LA_STRPTR,	Config -> PathConfig -> ASCIIDownloadPath,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,		VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_PATHPANEL_DEFAULT_TEXT_UPLOAD_PATH_GAD,
						LA_LabelChars,	Max,
						LA_ID,		GAD_TUPLOAD,
						LA_Chars,	20,
						LAST_Picker,	TRUE,
						GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
						LA_STRPTR,	Config -> PathConfig -> TextUploadPath,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_TDOWNLOAD,
						LA_LabelID,	MSG_PATHPANEL_DEFAULT_TEXT_DOWNLOAD_PATH_GAD,
						LA_LabelChars,	Max,
						LAST_Picker,	TRUE,
						GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
						LA_STRPTR,	Config -> PathConfig -> TextDownloadPath,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_PATHPANEL_DEFAULT_BINARY_UPLOAD_PATH_GAD,
						LA_LabelChars,	Max,
						LA_ID,		GAD_BUPLOAD,
						LA_Chars,	20,
						LAST_Picker,	TRUE,
						GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
						LA_STRPTR,	Config -> PathConfig -> BinaryUploadPath,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_BDOWNLOAD,
						LA_LabelID,	MSG_PATHPANEL_DEFAULT_BINARY_DOWNLOAD_PATH_GAD,
						LA_LabelChars,	Max,
						LAST_Picker,	TRUE,
						GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
						LA_STRPTR,	Config -> PathConfig -> BinaryDownloadPath,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_LabelID,	MSG_PATHPANEL_CONFIGURATION_STORAGE_DIR_GAD,
						LA_LabelChars,	Max,
						LA_ID,		GAD_CONFIGSTORE,
						LA_Chars,	20,
						LAST_Picker,	TRUE,
						GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
						LA_STRPTR,	Config -> PathConfig -> DefaultStorage,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_EDITOR,
						LA_LabelID,	MSG_PATHPANEL_DEFAULT_TEXT_EDITOR_GAD,
						LA_LabelChars,	Max,
						LAST_Picker,	TRUE,
						GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
						LA_STRPTR,	Config -> PathConfig -> Editor,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_HELPFILE,
						LA_LabelID,	MSG_PATHPANEL_HELP_TEXT_FILE_GAD,
						LA_LabelChars,	Max,
						LAST_Picker,	TRUE,
						GTST_MaxChars,	MAX_FILENAME_LENGTH - 1,
						LA_STRPTR,	Config -> PathConfig -> HelpFile,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	XBAR_KIND,
					LAXB_FullSize,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				if(Default)
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_GLOBAL_DEFAULT_GAD,
						LA_ID,		GAD_DEFAULT,
						LABT_ExtraFat,	TRUE,
					TAG_DONE);
				}

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_CANCEL_GAD,
					LA_ID,		GAD_CANCEL,
					LABT_EscKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(PanelWindow = LT_Layout(Handle,LocaleString(MSG_PATHPANEL_PATH_PREFERENCES_TXT),NULL,0,0,IDCMP_CLOSEWINDOW,0,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Window,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass,
						 MsgQualifier;
			UWORD			 MsgCode;
			struct Gadget		*MsgGadget;

			GuideContext(CONTEXT_PATHS);

			PushWindow(PanelWindow);

			LT_ShowWindow(Handle,TRUE);

			do
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					SaveConfig(PrivateConfig,Config);

					break;
				}

				while(Message = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort))
				{
					MsgClass	= Message -> Class;
					MsgQualifier	= Message -> Qualifier;
					MsgCode		= Message -> Code;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					GT_ReplyIMsg(Message);

					LT_HandleInput(Handle,MsgQualifier,&MsgClass,&MsgCode,&MsgGadget);

					if(MsgClass == IDCMP_CLOSEWINDOW)
					{
						SaveConfig(PrivateConfig,Config);

						Done = TRUE;
					}

					if(MsgClass == IDCMP_GADGETUP)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_USE:

								LT_UpdateStrings(Handle);

								Done = TRUE;
								break;

							case GAD_CANCEL:

								SaveConfig(PrivateConfig,Config);

								Cancel = Done = TRUE;
								break;

							case GAD_DEFAULT:

								*Default = TRUE;

								Done = TRUE;
								break;

							default:

								if(MsgGadget -> GadgetID >= GAD_AUPLOAD && MsgGadget -> GadgetID <= GAD_HELPFILE)
								{
									if(TypeOfMem((APTR)LT_GetAttributes(Handle,MsgGadget -> GadgetID,TAG_DONE)))
									{
										UBYTE DummyBuffer[MAX_FILENAME_LENGTH];

										strcpy(DummyBuffer,(STRPTR)LT_GetAttributes(Handle,MsgGadget -> GadgetID,TAG_DONE));

										if(MsgGadget -> GadgetID < GAD_EDITOR)
											FindDrawer(PanelWindow,DummyBuffer,TRUE,NULL);
										else
										{
											if(MsgGadget -> GadgetID == GAD_EDITOR)
												FindProgram(PanelWindow,DummyBuffer,NULL);
											else
												FindFile(PanelWindow,DummyBuffer,NULL);
										}
									}
								}

								break;
						}
					}

					if(MsgClass == IDCMP_IDCMPUPDATE)
					{
						if(MsgGadget -> GadgetID >= GAD_AUPLOAD && MsgGadget -> GadgetID <= GAD_HELPFILE)
						{
							WORD	ID	= MsgGadget -> GadgetID;
							STRPTR	Name	= LT_GetString(Handle,ID);

							if(Name)
							{
								UBYTE			 DummyBuffer[MAX_FILENAME_LENGTH],
											*DummyChar;
								struct FileRequester	*FileRequest;

								LT_LockWindow(PanelWindow);

								strcpy(DummyBuffer,Name);

								if(ID < GAD_EDITOR || !DummyBuffer[0])
									DummyChar = "";
								else
								{
									if(FilePart(DummyBuffer) == DummyBuffer)
										DummyBuffer[0] = 0;
									else
									{
										DummyChar = PathPart(DummyBuffer);

										*DummyChar = 0;
									}

									DummyChar = FilePart(Name);
								}

								if(FileRequest = GetFile(PanelWindow,LocaleString(ID - GAD_AUPLOAD + MSG_PATHPANEL_SELECT_DEFAULT_ASCII_UPLOAD_PATH_TXT),DummyBuffer,DummyChar,DummyBuffer,NULL,FALSE,FALSE,ID < GAD_EDITOR,LocaleString(MSG_GLOBAL_SELECT_TXT),TRUE))
								{
									if(ID < GAD_EDITOR)
										FindDrawer(PanelWindow,DummyBuffer,TRUE,NULL);
									else
									{
										if(ID == GAD_EDITOR)
											FindProgram(PanelWindow,DummyBuffer,NULL);
										else
											FindFile(PanelWindow,DummyBuffer,NULL);
									}

									LT_SetAttributes(Handle,ID,
										GTST_String,	DummyBuffer,
									TAG_DONE);

									FreeAslRequest(FileRequest);
								}

								LT_UnlockWindow(PanelWindow);
							}
						}
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}

	if(Default)
		return((BYTE)(!Cancel));
	else
	{
		if(Config -> PathConfig && Config -> TransferConfig && Config -> MiscConfig)
		{
			if(Config -> MiscConfig -> ProtectiveMode && !Config -> TransferConfig -> OverridePath)
			{
				STRPTR	Library	= NULL,
					Path	= NULL;

				if(Config -> TransferConfig -> DefaultType == XFER_XPR && Config -> TransferConfig -> DefaultLibrary[0])
				{
					Library	= Config -> TransferConfig -> DefaultLibrary;
					Path	= Config -> PathConfig -> BinaryDownloadPath;
				}

				if(Config -> TransferConfig -> ASCIIDownloadType == XFER_XPR && Config -> TransferConfig -> ASCIIDownloadLibrary[0])
				{
					Library	= Config -> TransferConfig -> ASCIIDownloadLibrary;
					Path	= Config -> PathConfig -> ASCIIDownloadPath;
				}

				if(Config -> TransferConfig -> TextDownloadType == XFER_XPR && Config -> TransferConfig -> TextDownloadLibrary[0])
				{
					Library	= Config -> TransferConfig -> TextDownloadLibrary;
					Path	= Config -> PathConfig -> TextDownloadPath;
				}

				if(Config -> TransferConfig -> BinaryDownloadType == XFER_XPR && Config -> TransferConfig -> BinaryDownloadLibrary[0])
				{
					Library	= Config -> TransferConfig -> BinaryDownloadLibrary;
					Path	= Config -> PathConfig -> BinaryDownloadPath;
				}

				if(Library && Path)
				{
					UBYTE LocalBuffer[MAX_FILENAME_LENGTH];

					if(*Path == 0)
					{
						if(GetCurrentDirName(LocalBuffer,MAX_FILENAME_LENGTH))
							Path = LocalBuffer;
					}

					if(MyEasyRequest(Window,LocaleString(MSG_XPR_PATH_TXT),LocaleString(MSG_GLOBAL_YES_NO_TXT),Library,Path))
						Config -> TransferConfig -> OverridePath = TRUE;
				}
			}
		}

		return((BYTE)memcmp(PrivateConfig -> PathConfig,Config -> PathConfig,sizeof(struct PathSettings)));
	}
}
